package mezz.jei.common.network.packets;

import mezz.jei.common.network.ClientPacketContext;
import mezz.jei.common.network.ClientPacketData;
import mezz.jei.common.network.IPacketId;
import mezz.jei.common.network.PacketIdClient;
import mezz.jei.common.network.packets.handlers.ClientCheatPermissionHandler;
import net.minecraft.class_2540;
import net.minecraft.class_310;
import java.util.concurrent.CompletableFuture;

public class PacketCheatPermission extends PacketJei {
	private final boolean hasPermission;

	public PacketCheatPermission(boolean hasPermission) {
		this.hasPermission = hasPermission;
	}

	@Override
	public IPacketId getPacketId() {
		return PacketIdClient.CHEAT_PERMISSION;
	}

	@Override
	public void writePacketData(class_2540 buf) {
		buf.writeBoolean(hasPermission);
	}

	public static CompletableFuture<Void> readPacketData(ClientPacketData data) {
		class_2540 buf = data.buf();
		boolean hasPermission = buf.readBoolean();
		class_310 minecraft = class_310.method_1551();
		ClientPacketContext context = data.context();
		return minecraft.method_20493(() -> ClientCheatPermissionHandler.handleHasCheatPermission(context, hasPermission));
	}
}
