package mezz.jei.common.util;

import com.mojang.blaze3d.systems.RenderSystem;
import java.util.HashMap;
import java.util.Map;
import net.minecraft.class_332;
import net.minecraft.class_4587;

public final class RectDebugger {
    public static final RectDebugger INSTANCE = new RectDebugger();

    private record Rect(ImmutableRect2i rect, int color) {

    }

    private final Map<String, Rect> rects = new HashMap<>();

    private RectDebugger() {

    }

    public void add(ImmutableRect2i rect, int color, String id) {
        this.rects.put(id, new Rect(rect, color));
    }

    public void draw(class_4587 poseStack) {
        RenderSystem.disableDepthTest();

        for (Rect rect : rects.values()) {
            ImmutableRect2i rect1 = rect.rect;
            class_332.method_25294(
                poseStack,
                rect1.getX(),
                rect1.getY(),
                rect1.getX() + rect1.getWidth(),
                rect1.getY() + rect1.getHeight(),
                rect.color
            );
        }
        RenderSystem.setShaderColor(1f, 1f, 1f, 1f);
    }
}
